//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
#include "Orsa.h"
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include "hyiedefs.hpp"
#include "hyieutils.hpp"
#include "ieopensavedlg.hpp"
#include "iesettings.hpp"
#include "ievect.hpp"
#include "ieview.hpp"
#include "iexBitmaps.hpp"
#include "imageenview.hpp"
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TOpenImageEnDialog *openDialog;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TStatusBar *StatusBarSource;
	TImageEnVect *PaintSource;
	TTabSheet *TabSheet2;
	TImageEnVect *PaintTarget;
	TStatusBar *StatusBarTarget;
	TTabSheet *TabSheet3;
	TImageEnVect *PaintMatch;
	TStatusBar *StatusBarMatch;
	TTabSheet *TabSheet4;
	TImageEnVect *PaintPanorama;
	TTabSheet *TabSheet5;
	TImageEnVect *PaintReg1;
	TTabSheet *TabSheet6;
	TImageEnVect *PaintReg2;
	TPanel *Panel1;
	TLabel *labSigma;
	TLabel *labMatch;
	TLabel *labPrecission;
	TButton *btnSiftSource;
	TButton *btnLoadSource;
	TButton *btnLoadTarget;
	TButton *btnSiftTarget;
	TButton *btnMatch;
	TButton *btnOrsa;
	TTrackBar *trackSigma;
	TTrackBar *trackMatch;
	TTrackBar *trackPrecission;
	TRadioGroup *rgpMatches;
	TCheckBox *chkIntersection;
	TCheckBox *chkTranslate;
	void __fastcall btnLoadSourceClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall btnSiftSourceClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall btnLoadTargetClick(TObject *Sender);
	void __fastcall btnSiftTargetClick(TObject *Sender);
	void __fastcall btnMatchClick(TObject *Sender);
	void __fastcall btnOrsaClick(TObject *Sender);
	void __fastcall trackSigmaChange(TObject *Sender);
	void __fastcall trackMatchChange(TObject *Sender);
	void __fastcall trackPrecissionChange(TObject *Sender);
	void __fastcall rgpMatchesClick(TObject *Sender);
	void __fastcall chkIntersectionClick(TObject *Sender);
	void __fastcall chkTranslateClick(TObject *Sender);
private:	// User declarations
	HINSTANCE dll_instance;
    int ExecutionStatus;
    ORSA_entry ExecuteAddr;
	siftPar  SiftParams;
	orsaData DataOrsa;
	int prevSigma;
	bool sourceNew, targetNew;
	void __fastcall processSift(TImageEnVect *paint);
	void __fastcall processMatches(void);
	void __fastcall showMatches(int index);
	void __fastcall executeEntry(String entry_name);
	void __fastcall getScline(imageData &image, TIEBitmap *bitmap);
	TIEBitmap* __fastcall BitmapFromScline(imageData &image);
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
